// DSIH.h : Declaration of the CDSIH

#pragma once
#include "resource.h"       // main symbols

#include "DAZStudioIconHandler_i.h"

#include <gdiplus.h>
#include <shlobj.h>

// CDSIH
class ATL_NO_VTABLE CDSIH :
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CDSIH, &CLSID_DSIH>,
	public IDSIH,
	public IPersistFile,
	public IExtractIcon
{
public:
	CDSIH();
	virtual ~CDSIH();

	DECLARE_REGISTRY_RESOURCEID(IDR_DSIH)

	DECLARE_NOT_AGGREGATABLE(CDSIH)

	BEGIN_COM_MAP(CDSIH)
		COM_INTERFACE_ENTRY(IDSIH)
		COM_INTERFACE_ENTRY(IPersistFile)
		COM_INTERFACE_ENTRY(IExtractIcon)
	END_COM_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease()
	{
	}

private:
	TCHAR m_szFileName[MAX_PATH];
	TCHAR m_szDefaultIconLocation[MAX_PATH];
	int m_iDefaultIconPosition;
	ULONG_PTR m_gdiplusToken;

	// Convert a PNG into an icon
	STDMETHODIMP ImageToIcon (Gdiplus::Image*, HICON*, int);

	// Get the default file icon location
	void getDefaultIcon (LPCTSTR);

public:
	// Implement IPersistFile interface
	STDMETHODIMP GetClassID (CLSID*);
	STDMETHODIMP IsDirty() { return S_FALSE; }
	STDMETHODIMP Load (LPCOLESTR, DWORD);
	STDMETHODIMP Save (LPCOLESTR, BOOL) { return E_FAIL; }
	STDMETHODIMP SaveCompleted (LPCOLESTR) { return E_FAIL; }
	STDMETHODIMP GetCurFile (LPOLESTR*) { return E_FAIL; }

	// Implement IExtractIcon interface
	STDMETHODIMP GetIconLocation (UINT, LPTSTR, UINT, int*, UINT*);
	STDMETHODIMP Extract (LPCTSTR, UINT, HICON*, HICON*, UINT);
};

OBJECT_ENTRY_AUTO(__uuidof(DSIH), CDSIH)