// DSTIH.h : Declaration of the CDSTIH

#pragma once
#include "resource.h"       // main symbols

#include "DAZStudioThumbnailImageHandler_i.h"

#include <gdiplus.h>
#include <shlobj.h>
#include <thumbcache.h>

// CDSTIH
class ATL_NO_VTABLE CDSTIH :
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CDSTIH, &CLSID_DSTIH>,
	public IDSTIH,
	public IInitializeWithFile,
	public IThumbnailProvider
{
public:
	CDSTIH();
	virtual ~CDSTIH();

	DECLARE_REGISTRY_RESOURCEID(IDR_DSTIH)

	DECLARE_NOT_AGGREGATABLE(CDSTIH)

	BEGIN_COM_MAP(CDSTIH)
		COM_INTERFACE_ENTRY(IDSTIH)
		COM_INTERFACE_ENTRY(IInitializeWithFile)
		COM_INTERFACE_ENTRY(IThumbnailProvider)
	END_COM_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease()
	{
	}

private:
	TCHAR m_szPNGFileName[MAX_PATH];
	ULONG_PTR m_gdiplusToken;

public:
	// Implement IInitializeWithFile interface
	STDMETHODIMP Initialize (LPCWSTR, DWORD);

	// Implement IThumbnailProvider interface
	STDMETHODIMP GetThumbnail (UINT, HBITMAP*, WTS_ALPHATYPE*);
};

OBJECT_ENTRY_AUTO(__uuidof(DSTIH), CDSTIH)